<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8"/>
<title>Validation of DATEX II</title>
<meta name="author" content="Jan Vlčinský, Andreas Dis, Edgar van Wilgenburg"/>
<style type="text/css">
.underline { text-decoration: underline; }
</style>
<link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/reveal.js/dist/reveal.css"/>

<link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/reveal.js/dist/theme/black.css" id="theme"/>
</head>
<body>
<div class="reveal">
<div class="slides">
<section id="sec-title-slide" data-background="./images/title.jpeg">
<h1><br/><br/></h1><h3>Validation of DATEX II</h3><h5>Message Class Model<br/>&amp;<br/>Serialized Message</h5><hr/><h6>Jan Vlčinský, Andreas Dis, Edgar van Wilgenburg</h6><hr/><h6>NAPCORE SWG4.1 - Virtual DATEX User Forum - 2023-10-04</h6>
</section>
<section>
<section id="slide-org4d67b08">
<h2 id="org4d67b08">Motivation</h2>
<p>
How to use DATEX II supported validation to:
</p>

<p>
🚀 speed up 🚀
</p>
<p class="verse">
system design and development<br />
deployment and operation<br />
fixing problems<br />
</p>

<p>
📈 improve 📈
</p>

<p>
quality of data exchange
</p>
</section>
</section>
<section>
<section id="slide-org8437da2">
<h2 id="org8437da2">NAPCORE SWG4.1 - DATEX II</h2>
<p class="verse">
<img src="./images/napcore-logo.png" alt="napcore-logo.png" /><br />
<a href="https://napcore.eu/">https://napcore.eu/</a><br />
</p>

<p class="verse">
<a href="https://datex2.eu">https://datex2.eu</a><br />
</p>

<div id="org6bb24bd" class="figure">
<p><img src="./images/co-funded-by-eu.png" alt="co-funded-by-eu.png" />
</p>
</div>
</section>
</section>
<section>
<section id="slide-org60c592f">
<h2 id="org60c592f">Presenters</h2>
<div class="outline-text-2" id="text-org60c592f">
</div>
</section>
<section id="slide-orgfc113c6">
<h3 id="orgfc113c6">Jan Vlčinský</h3>
<p>
<a href="mailto:jan.vlcinsky@tamtamresearch.com">jan.vlcinsky@tamtamresearch.com</a>
</p>

<p>
Executive Researcher at TamTam Research, Czechia
</p>

<p>
featuring
</p>

<p class="verse">
Validation Concepts and Context,<br />
Local Validators<br />
and Daily Validations of published data (InQMS)<br />
</p>
</section>
<section id="slide-org688a4f0">
<h3 id="org688a4f0">Andreas Dis</h3>
<p>
<a href="mailto:Andreas.Dis@austriatech.at">Andreas.Dis@austriatech.at</a>
</p>

<p>
Data Analyst at Austriatech, Austria
</p>

<p>
featuring
</p>

<p>
On-line class model validator at RAV Centre
</p>
</section>
<section id="slide-org3e3f11a">
<h3 id="org3e3f11a">Edgar van Wilgenburg</h3>
<p>
<a href="mailto:edgar.van.wilgenburg@ndw.nu">edgar.van.wilgenburg@ndw.nu</a>
</p>

<p>
Information Architect at Nationaal Dataportaal Wegverkeer (NDW), The Netherlands
</p>

<p>
featuring
</p>

<p>
On-line serialized message validator at NDW
</p>
</section>
</section>
<section>
<section id="slide-org858b62e">
<h2 id="org858b62e">Topics</h2>
<ul>
<li><b><span class="underline">Fixing the</span></b> World - faster</li>
<li>DATEX II message <b><span class="underline">class model</span></b> validation</li>
<li>Serialized DATEX II <b><span class="underline">message</span></b> validation</li>
<li>Questions &amp; Answers</li>

</ul>
</section>
<section id="slide-org86d6018">
<h3 id="org86d6018">Highlights</h3>
<p>
DATEX II Context and Concepts for validation
</p>

<p>
Tools and demo:
</p>
<p class="verse">
on-line DATEX II RAV Center class model validator<br />
local message validators<br />
on-line message validator at NDW<br />
InQMS: daily message validations of Czech content<br />
</p>
<p>
&#x2014;
</p>

<p>
Validate to fix things faster
</p>
</section>
</section>
<section>
<section id="slide-orgc6c6f7c" data-background="#ffffff">
<h2 id="orgc6c6f7c">Introduction to Validation</h2>
<p>
by Jan Vlčinský, TamTam Research
</p>
</section>
<section id="slide-org2d11047">
<h3 id="org2d11047">Validation Concept</h3>

<div id="org1be1c6a" class="figure">
<p><img src="./images/concept.svg" alt="concept.svg" class="org-svg" />
</p>
</div>
<aside class="notes">
<p>
Value: provide feedback, allow improvement
</p>

<p>
Examples:
</p>
<ul>
<li>driving: speed limit / policemen + radar / ticket or chocolate</li>
<li>house: blueprint + contract / supervisor + lawer / &#x2026;</li>
<li>SW : test suite / test runner / test resport</li>

</ul>

</aside>
</section>
<section id="slide-orge5affc9">
<h3 id="orge5affc9">DATEX II Context and Concepts</h3>

<div id="org0d9e368" class="figure">
<p><img src="./images/d2context.png" alt="d2context.png" />
</p>
</div>
<aside class="notes">
<p>
I will explain key DATEX II terms and concepts, which are relevant for understanding specific DATEX II validation topics.
</p>

<p>
You will see this diagram few more times to depict scope of upcoming presented topics.
</p>

<p>
top row: general intention:
</p>
<ul>
<li>provide or consume some <b>data</b></li>
<li>using agreed data <b>structure</b></li>
<li>expressing <b>important aspects of information</b></li>
<li>fulfilling <b>user needs</b></li>

</ul>
<p>
D2 terms:
</p>
<ul>
<li>PIM (Platform Independent Model): (analytical) class model, abstracting specific format</li>
<li>PSM (Platform Specific Model): (deployment) platform/format specific structure</li>
<li>model platform = formats: e.g. XML, JSON or (experimental) ASN.1</li>

<li>Types of validation</li>

</ul>

</aside>
</section>
</section>
<section>
<section id="slide-orgada7648" data-background="#ffffff">
<h2 id="orgada7648"><b>DATEX II message class model</b> validation</h2>
<p>
by Andreas Dis, Austriatech
</p>

<p>
&#x2014;
</p>
<p class="verse">
DATEX II RAV Center (on-line) class model validator<br />
</p>
</section>
<section id="slide-orgf647489">
<h3 id="orgf647489">Scope: Message class model</h3>

<div id="org2f9e9e2" class="figure">
<p><img src="./images/d2context-class-validation.png" alt="d2context-class-validation.png" />
</p>
</div>
<aside class="notes">
<p>
Evaluating platform independent model (PIM)
</p>

<p>
Testing class model for the DATEX II message
</p>

<p>
Especially, it checks, that the profiling of the message class model did not remove from the classes the information, expected/requied by related delegated regulation 885/2013 for SSTP.
</p>

<p>
In fact, the .SEL file represents the choices during profiling process and we validate, that the proces of stripping down the model did not go too far.
</p>

</aside>
</section>
<section id="slide-orgc8a9c6f">
<h3 id="orgc8a9c6f">The DATEX II RAV Centre</h3>
<p>
RAV = Reference Advice and Validation
<a href="https://testcenter.datex2.eu/xmlchk/">https://testcenter.datex2.eu/xmlchk/</a>
</p>

<p>
Currently validates: profiles against Commission&rsquo;s Delegated Regulations (EU) reference profile on secure truck parking information (No 885/2013) in DATEX II Version 2.3.
</p>
</section>
<section id="slide-orgf3c600c">
<h3 id="orgf3c600c">RAV Demo</h3>
<ul>
<li>find the validator</li>
<li>upload the .SEL file</li>
<li>see the report
<ul>
<li>when some issues are detected</li>
<li>when all things are OK</li>

</ul></li>

</ul>
</section>
<section id="slide-orgc56fc21">
<h4 id="orgc56fc21">Upload a .SEL file</h4>

<div id="org9d47ba2" class="figure">
<p><img src="./images/rav/upload.png" alt="upload.png" />
</p>
</div>
</section>
<section id="slide-orgbbcfb43">
<h4 id="orgbbcfb43">Get Validation Report with Errors</h4>

<div id="orgb5eb0c0" class="figure">
<p><img src="./images/rav/rpt_err.png" alt="rpt_err.png" />
</p>
</div>
</section>
<section id="slide-org6b7cc5c">
<h4 id="org6b7cc5c">Get Validation Report (all good)</h4>

<div id="org40f6daa" class="figure">
<p><img src="./images/rav/rpt_ok.png" alt="rpt_ok.png" />
</p>
</div>
</section>
</section>
<section>
<section id="slide-orgb9722c9" data-background="#ffffff">
<h2 id="orgb9722c9"><b>Serialized DATEX II message</b> validation</h2>
<p>
by Jan Vlčinský, TamTam Research
</p>
<p class="verse">
<span class="underline">Use cases</span> and <span class="underline">value</span> for publisher and consumer<br />
<span class="underline">Publishing a schema</span> within an hour<br />
JSON/XML/ASN.1 <span class="underline">schema types</span><br />
XML <span class="underline">validators</span>: local/desktop/on-line<br />
</p>
</section>
<section id="slide-org496d857">
<h3 id="org496d857">Scope: Serialized Message</h3>

<div id="org7a53ca1" class="figure">
<p><img src="./images/d2context-message-validation.png" alt="d2context-message-validation.png" />
</p>
</div>
</section>
<section id="slide-orge9805ed">
<h3 id="orge9805ed">XML/JSON/ASN.1 Schema Use Cases</h3>
<p>
Message validation
</p>

<p>
Code generation
</p>
</section>
<section id="slide-org7cd93d7">
<h4 id="org7cd93d7">Message Validation</h4>
<ul>
<li>Is the <span class="underline">sample in specs</span> valid?</li>
<li>Test case for <span class="underline">message serializing</span> code</li>
<li>Is the <span class="underline">outgoing message</span> valid?</li>
<li>Is the <span class="underline">ingoing message</span> valid?</li>
<li>Test case for <span class="underline">message deserializing</span> code</li>

</ul>
</section>
<section id="slide-org0101235">
<h4 id="org0101235">Code generation:</h4>
<ul>
<li>Server side code</li>
<li>Client side code</li>
<li>Class instance to message (serialization)</li>
<li>Message to class instance (deserialization)</li>

</ul>
</section>
<section id="slide-org04e4a03">
<h3 id="org04e4a03">Use Cases in System Lifecycle</h3>

<div id="orgae1563a" class="figure">
<p><img src="./images/use-cases.png" alt="use-cases.png" />
</p>
</div>
</section>
</section>
<section>
<section id="slide-org0c714c5">
<h2 id="org0c714c5">Importance of accessible schema</h2>
<p class="verse">
Lack of<br />
relevant XML/JSON/ASN.1 Schema<br />
</p>
<p>
☠ KILLS all the benefits ☠
</p>

<p>
&#x2014;
</p>

<p>
This is where NAP plays the key role.
</p>
</section>
<section id="slide-org6228caf">
<h3 id="org6228caf">Publishing the Schema can be easy</h3>
<ul>
<li><p>
Directory Content:
</p>
<div class="org-src-container">

<pre class="src src-shell">  schema/schema.xsd <span style="color: #5B6268;"># </span><span style="color: #5B6268;">mission accomplished!!!</span>
  samples/*.xml <span style="color: #5B6268;"># </span><span style="color: #5B6268;">nice to have</span>
  FORMAT.yaml <span style="color: #5B6268;"># </span><span style="color: #5B6268;">metadata</span>
  sel/fname.sel <span style="color: #5B6268;"># </span><span style="color: #5B6268;">optional</span>
</pre>
</div></li>
<li>Publish on GitHub/GitLab:
<ul>
<li>e.g. <a href="https://gitlab.com/datex2/profile/cz-ndic_d2-common">cz-ndic_d2-common</a></li>

</ul></li>
<li>GitLab bonus: 🌲 <a href="https://gitlab.com/datex2">multi-level repo/profile groups</a></li>

</ul>
</section>
</section>
<section>
<section id="slide-orgceac86e" data-background="#ffffff">
<h2 id="orgceac86e">Validation of: JSON</h2>
<p>
There are multiple JSON Schema variants:
</p>
<ul>
<li class="on"><code>[X]</code> JSON Schema Draft 4</li>
<li class="off"><code>[&#xa0;]</code> JSON Schema Draft 5</li>
<li class="off"><code>[&#xa0;]</code> JSON Schema Draft 6</li>
<li class="off"><code>[&#xa0;]</code> JSON Schema Draft 7</li>
<li class="off"><code>[&#xa0;]</code> JSON Draft 2019-09</li>
<li class="off"><code>[&#xa0;]</code> JSON Draft 2020-12</li>

</ul>

<p>
&#x2014;
</p>

<p>
DATEX II uses Draft 4
</p>
</section>
</section>
<section>
<section id="slide-orga39a156" data-background="#ffffff">
<h2 id="orga39a156">Validation of: XML</h2>
<p>
There are multiple XML Schema variants:
</p>
<ul>
<li class="on"><code>[X]</code> W3C XML Schema v1.0</li>
<li class="off"><code>[&#xa0;]</code> W3C XML Schema v1.1</li>
<li class="off"><code>[&#xa0;]</code> RELAX NG (XML and Compact Syntax)</li>
<li class="off"><code>[&#xa0;]</code> Schematron</li>

</ul>

<p>
&#x2014;
</p>

<p>
DATEX II uses W3C XML Schema v1.0
</p>
</section>
<section id="slide-orgd379f39">
<h3 id="orgd379f39">Local XML Schema validators</h3>
<table border="2" cellspacing="0" cellpadding="6" rules="groups" frame="hsides">


<colgroup>
<col  class="org-left" />

<col  class="org-left" />
</colgroup>
<tbody>
<tr>
<td class="org-left">💻</td>
<td class="org-left">Desktop: Altova XMLSpy, oXygen XML Editor, Stylus Studio, Liquid XML Studio, XMLPad, Exchanger XML Editor</td>
</tr>

<tr>
<td class="org-left">🎹</td>
<td class="org-left">CLI: xmlstarlet, xmllint, Xerces-C++ XML Parser, MSV, Saxon</td>
</tr>

<tr>
<td class="org-left">📜</td>
<td class="org-left">Code: pytest test case using <code>lxml</code> lib; +∞</td>
</tr>
</tbody>
</table>
<p>
You will find one or more for sure
</p>
</section>
<section id="slide-orgcd4b401">
<h3 id="orgcd4b401">CLI Validators for XML</h3>
<div class="org-src-container">

<pre class="src src-shell">$ xmlstarlet val <span style="color: #98be65;">\</span>
  --xsd schema/schema.xsd <span style="color: #98be65;">\</span>
  samples/message.xml
$ xmllint <span style="color: #98be65;">\</span>
  --schema schema/schema.xsd <span style="color: #98be65;">\</span>
  samples/message.xml
$ java -jar msv.jar <span style="color: #98be65;">\</span>
  schema/schema.xsd <span style="color: #98be65;">\</span>
  samples/message.xml
$ java -jar saxon9he.jar <span style="color: #98be65;">\</span>
  -s:samples/message.xml <span style="color: #98be65;">\</span>
  -xsd:schema/schema.xsd <span style="color: #98be65;">\</span>
  -val:strict
$ XercesCParser -v -s -n <span style="color: #98be65;">\</span>
  samples/message.xml <span style="color: #5B6268;"># </span><span style="color: #5B6268;">schema referenced within message.xml</span>
</pre>
</div>
</section>
</section>
<section>
<section id="slide-org6f4fb7a" data-background="#ffffff">
<h2 id="org6f4fb7a"><code>xmlstarlet</code> CLI for XML</h2>
<p>
Based on libxml2 (as xmllint or python lxml library)
</p>

<p>
Runs on Windows, Linux, MacOS..:
</p>
<ul>
<li>natively installed</li>
<li>via docker</li>

</ul>

<div class="org-src-container">

<pre class="src src-shell">$ <span style="color: #5B6268;"># </span><span style="color: #5B6268;">validate single file:</span>
$ xmlstarlet val --xsd schema/schema.xsd --err sample/message.xml
$ <span style="color: #5B6268;"># </span><span style="color: #5B6268;">validate multiple files</span>
$ xmlstarlet val --xsd schema/schema.xsd sample/*.xml
$ <span style="color: #5B6268;"># </span><span style="color: #5B6268;">list only invalid files</span>
$ xmlstarlet val --xsd schema/schema.xsd --list-bad sample/*.xml
</pre>
</div>
</section>
<section id="slide-org0fb5edd">
<h3 id="org0fb5edd"><code>xmlstarlet</code> via docker (Linux)</h3>
<p>
Pull and tag the docker image (once)
</p>
<div class="org-src-container">

<pre class="src src-shell">$ export <span style="color: #dcaeea;">IMAGE_URL</span>=registry.gitlab.com/datex2/presentation/2023-virtduf-validation/xmlstarlet-docker:1.0.0
$ docker pull $<span style="color: #dcaeea;">IMAGE_URL</span> <span style="color: #5B6268;"># </span><span style="color: #5B6268;">pull the image</span>
$ docker image tag $<span style="color: #dcaeea;">IMAGE_URL</span> xmlstarlet <span style="color: #5B6268;"># </span><span style="color: #5B6268;">and tag it e.g. as xmlstarlet</span>
</pre>
</div>
<p>
Use it for validation
</p>
<div class="org-src-container">

<pre class="src src-shell">$ docker run -it --rm -v $<span style="color: #dcaeea;">PWD</span>:/data xmlstarlet <span style="color: #98be65;">\</span>
  val --err <span style="color: #98be65;">\</span>
  --xsd schema/schema.xsd <span style="color: #98be65;">\</span>
  samples/accident.xml
  samples/accident.xml - valid
</pre>
</div>
<p>
<a href="https://gitlab.com/datex2/presentation/2023-virtduf-validation/xmlstarlet-docker">https://gitlab.com/datex2/presentation/2023-virtduf-validation/xmlstarlet-docker</a>
</p>
</section>
<section id="slide-org8ffcc00">
<h3 id="org8ffcc00"><code>xmlstarlet</code> via docker (Windows)</h3>
<p>
Pull and tag the docker image (once)
</p>
<div class="org-src-container">

<pre class="src src-bat">C:\DATEX2&gt;set IMAGE_URL=registry.gitlab.com/datex2/presentation/2023-virtduf-validation/xmlstarlet-docker:<span style="color: #da8548; font-weight: bold;">1.0</span>.<span style="color: #da8548; font-weight: bold;">0</span>
C:\DATEX2&gt;docker pull %<span style="color: #dcaeea;">IMAGE_URL</span>%
C:\DATEX2&gt;docker image tag %<span style="color: #dcaeea;">IMAGE_URL</span>% xmlstarlet
</pre>
</div>
<p>
Use it for validation
</p>
<div class="org-src-container">

<pre class="src src-bat">C:\DATEX2&gt;docker run -<span style="color: #ECBE7B;">it</span> --<span style="color: #ECBE7B;">rm</span> -<span style="color: #ECBE7B;">v</span> %<span style="color: #dcaeea;">cd</span>%:/data xmlstarlet ^
  val --<span style="color: #ECBE7B;">err</span> ^
  --<span style="color: #ECBE7B;">xsd</span> schema/schema.xsd ^
  samples/accident.xml

  samples/accident.xml - valid
</pre>
</div>
<p>
<a href="https://gitlab.com/datex2/presentation/2023-virtduf-validation/xmlstarlet-docker">https://gitlab.com/datex2/presentation/2023-virtduf-validation/xmlstarlet-docker</a>
</p>
</section>
</section>
<section>
<section id="slide-org05a0779" data-background="#ffffff">
<h2 id="org05a0779"><code>pytest</code> test case example (Python)</h2>
<p>
Conformance to a schema is crucial
</p>

<p>
Let your code do the work
</p>

<p>
Detects errors before committing the code
</p>

<p>
Makes code refactoring real fun
</p>

<p>
Example for Python
</p>

<p>
<a href="https://gitlab.com/datex2/presentation/2023-virtduf-validation/pytest-validate">https://gitlab.com/datex2/presentation/2023-virtduf-validation/pytest-validate</a>
</p>
</section>
<section id="slide-org4a1b9ad">
<h3 id="org4a1b9ad">tests/test_validate.py: imports</h3>
<div class="org-src-container">

<pre class="src src-python"><span style="color: #51afef;">from</span> pathlib <span style="color: #51afef;">import</span> Path

<span style="color: #51afef;">from</span> lxml <span style="color: #51afef;">import</span> etree

<span style="color: #51afef;">import</span> pytest
</pre>
</div>
</section>
<section>
<p>
tests/test_validate.py: messages to test
</p>
<div class="org-src-container">

<pre class="src src-python"><span style="color: #ECBE7B;">@pytest.fixture</span>(
    params=[
        <span style="color: #98be65;">"samples/accident.xml"</span>,
        <span style="color: #98be65;">"samples/brokendownvehicles.xml"</span>,
        <span style="color: #98be65;">"samples/restriction-bkom.xml"</span>,
        <span style="color: #98be65;">"samples/invalid_missig_lang.xml"</span>,
    ]
)
<span style="color: #51afef;">def</span> <span style="color: #c678dd;">message</span>(request):
    <span style="color: #83898d;">"""Parsed XML message (as lxml tree instance)"""</span>
    <span style="color: #dcaeea;">path</span> = Path(request.param)
    <span style="color: #51afef;">assert</span> path.exists()
    <span style="color: #dcaeea;">xml_doc</span> = etree.parse(<span style="color: #c678dd;">str</span>(path))
    <span style="color: #51afef;">return</span> xml_doc
</pre>
</div>
</section>
<section>
<p>
tests/test_validate.py: schema to use
</p>
<div class="org-src-container">

<pre class="src src-python"><span style="color: #ECBE7B;">@pytest.fixture</span>
<span style="color: #51afef;">def</span> <span style="color: #c678dd;">schema</span>():
    <span style="color: #83898d;">"""W3C XML Schema (lxml XMLSchema instance)"""</span>
    <span style="color: #dcaeea;">path</span> = Path(<span style="color: #98be65;">"schema/schema.xsd"</span>)
    <span style="color: #51afef;">assert</span> path.exists()
    <span style="color: #dcaeea;">xsd_doc</span> = etree.parse(path)
    <span style="color: #dcaeea;">xml_schema</span> = etree.XMLSchema(xsd_doc)
    <span style="color: #51afef;">return</span> xml_schema
</pre>
</div>
</section>
<section>
<p>
tests/test_validate.py: actual test
</p>
<div class="org-src-container">

<pre class="src src-python"><span style="color: #51afef;">def</span> <span style="color: #c678dd;">test_validate</span>(schema, message):
    <span style="color: #83898d;">"""Test that the `message` conforms to `schema`"""</span>
    <span style="color: #51afef;">assert</span> schema.validate(message), f<span style="color: #98be65;">"Invalid: </span>{schema.error_log}<span style="color: #98be65;">"</span>
</pre>
</div>
</section>
<section id="slide-orgfb01bd2">
<h3 id="orgfb01bd2">run the pytest test suite</h3>
<p>
call the test
</p>
<div class="org-src-container">

<pre class="src src-shell">$ pdm run pytest -sv tests
</pre>
</div>
<p>
and see the test report: header
</p>
<div class="org-src-container">

<pre class="src src-shell">============================= test session starts ==============================
platform linux -- Python 3.11.4, pytest-7.4.2, pluggy-1.3.0 -- /home/javl/devel/datex2/gitlab/presentation/2023-virtduf-validation/pytest-validate/.venv/bin/python
cachedir: .pytest_cache
rootdir: /home/javl/devel/datex2/gitlab/presentation/2023-virtduf-validation/pytest-validate
collecting ... collected <span style="color: #da8548; font-weight: bold;">4</span> items
...
</pre>
</div>
</section>
<section>
<p>
test report: Short summary test results
</p>
<div class="org-src-container">

<pre class="src src-shell">...
collecting ... collected <span style="color: #da8548; font-weight: bold;">4</span> items
tests/test_validate.py::test_validate<span style="color: #51afef;">[</span>samples/accident.xml<span style="color: #51afef;">]</span> PASSED
tests/test_validate.py::test_validate<span style="color: #51afef;">[</span>samples/brokendownvehicles.xml<span style="color: #51afef;">]</span> PASSED
tests/test_validate.py::test_validate<span style="color: #51afef;">[</span>samples/restriction-bkom.xml<span style="color: #51afef;">]</span> PASSED
tests/test_validate.py::test_validate<span style="color: #51afef;">[</span>samples/invalid_missig_lang.xml<span style="color: #51afef;">]</span> FAILED

=================================== FAILURES ===================================
</pre>
</div>
</section>
<section>
<p>
test report: Detailed failure description
</p>
<div class="org-src-container">

<pre class="src src-shell">...
=================================== FAILURES ===================================
________________ test_validate<span style="color: #51afef;">[</span>samples/invalid_missig_lang.xml<span style="color: #51afef;">]</span> ________________

schema = &lt;lxml.etree.XMLSchema object at 0x7ffb1e93f9c0&gt;
message = &lt;lxml.etree._ElementTree object at 0x7ffb1e995740&gt;

    def test_validate<span style="color: #51afef;">(</span>schema, message<span style="color: #51afef;">)</span>:
&gt;       assert schema.validate<span style="color: #51afef;">(</span>message<span style="color: #51afef;">)</span>, f<span style="color: #98be65;">"Invalid: {schema.error_log}"</span>
E       AssertionError: Invalid: samples/invalid_missig_lang.xml:11:0:ERROR:SCHEMASV:SCHEMAV_CVC_COMPLEX_TYPE_4: Element <span style="color: #98be65;">'{http://datex2.eu/schema/2/2_0}payloadPublication'</span>: The attribute <span style="color: #98be65;">'lang'</span> is required but missing.
E       assert False
E        +  where False = &lt;bound method _Validator.validate of &lt;lxml.etree.XMLSchema object at 0x7ffb1e93f9c0&gt;&gt;<span style="color: #51afef;">(</span>&lt;lxml.etree._ElementTree object at 0x7ffb1e995740&gt;<span style="color: #51afef;">)</span>
E        +    where &lt;bound method _Validator.validate of &lt;lxml.etree.XMLSchema object at 0x7ffb1e93f9c0&gt;&gt; = &lt;lxml.etree.XMLSchema object at 0x7ffb1e93f9c0&gt;.validate

tests/test_validate.py:33: AssertionError
=========================== short test summary info ============================
</pre>
</div>
</section>
<section>
<p>
test report: short test summary info
</p>
<div class="org-src-container">

<pre class="src src-shell">=========================== short test summary info ============================
FAILED tests/test_validate.py::test_validate<span style="color: #51afef;">[</span>samples/invalid_missig_lang.xml<span style="color: #51afef;">]</span>
========================= <span style="color: #da8548; font-weight: bold;">1</span> failed, <span style="color: #da8548; font-weight: bold;">3</span> passed<span style="color: #51afef;"> in</span> 0.08s ==========================
</pre>
</div>

<p>
<a href="https://gitlab.com/datex2/presentation/2023-virtduf-validation/pytest-validate">https://gitlab.com/datex2/presentation/2023-virtduf-validation/pytest-validate</a>
</p>
</section>
</section>
<section>
<section id="slide-orged7fd26" data-background="#ffffff">
<h2 id="orged7fd26">NDW Online Message Validator</h2>
<p>
by Edgar van Wilgenburg, NDW
</p>

<p>
&#x2014;
</p>
<p class="verse">
On-line XML message validation<br />
for selected DATEX II Profiles<br />
</p>
</section>
<section id="slide-org4dc44ee">
<h3 id="org4dc44ee">Scope: Serialized XML Message</h3>

<div id="orgd864722" class="figure">
<p><img src="./images/d2context-ndw-validator.png" alt="d2context-ndw-validator.png" />
</p>
</div>
</section>
<section id="slide-org9b1faad">
<h3 id="org9b1faad">The purpose of NDW validator</h3>
<p>
Stop expensive exchanges of structurally broken data
</p>

<p>
Quick and Easy (On-Line) Validation
</p>

<p>
Directory of Agreed profiles
</p>

<p>
Accessible to All types of Users
</p>
</section>
<section id="slide-org2354b42">
<h3 id="org2354b42">About the NDW validator</h3>
<p>
<a href="https://d2val.staging.ndw.nu/">https://d2val.staging.ndw.nu/</a>
</p>

<p>
Python + Flask web app (+ Bash + xmllint).
</p>

<p>
For DATEX II XML messages.
</p>

<p>
Accepts gzipped files.
</p>

<p>
Checks for: schema defined structure.
</p>

</section>
<section>

<div id="org52412ae" class="figure">
<p><img src="./images/you-shall-not-pass.jpg" alt="you-shall-not-pass.jpg" />
</p>
</div>

<p>
Let&rsquo;s meet our <a href="https://d2val.staging.ndw.nu/">on-line Gandalf</a>
</p>
</section>
<section id="slide-orgf705dd1">
<h3 id="orgf705dd1">NDW validator Demo</h3>
<ol>
<li>Select a Profile</li>
<li>Upload Your XML</li>
<li>See the validation report</li>

</ol>

<p>
Repeat for valid/invalid DATEX II Message
</p>
</section>
<section id="slide-org6d080eb">
<h3 id="org6d080eb">Summary of NDW validator</h3>
<div class="outline-text-3" id="text-org6d080eb">
</div>
</section>
<section id="slide-org456d976">
<h4 id="org456d976">Current Status</h4>
<p>
very easy to use
</p>

<p>
very clear answer (one of):
</p>

<p>
<b><span class="underline">you are fine</span></b> or <b><span class="underline">list of things to fix</span></b>
</p>
</section>
<section id="slide-orgf627f68">
<h4 id="orgf627f68">Space for improvement</h4>
<ol>
<li>simpler profile selection</li>
<li>downloadable profile related schemas</li>

</ol>
</section>
</section>
<section>
<section id="slide-orgc9b02ca" data-background="#ffffff">
<h2 id="orgc9b02ca">InQMS: Validate them all</h2>
<p>
by Jan Vlčinský, TamTam Research
</p>

<p>
&#x2014;
</p>

<p class="verse">
Let&rsquo;s try to<br />
validate<br />
all the published messages<br />
<a href="https://inqms.tamtamresearch.com/">https://inqms.tamtamresearch.com/</a><br />
</p>

<p>
&#x2014;
</p>

<p>
Tested with Czech NDIC content.
</p>
</section>
<section id="slide-org122fd63">
<h3 id="org122fd63">InQMS Architecture</h3>
<ul>
<li>Collect and Archive</li>
<li>Evaluate (once a day)</li>
<li>Visualize (Grafana)</li>

</ul>
</section>
<section id="slide-orgc2759ca">
<h3 id="orgc2759ca">Validation Features</h3>
<p>
List all the published messages:
</p>
<ul>
<li>One validation report per message</li>
<li>The message itself</li>

</ul>

<p>
&#x2014;
</p>

<p>
Makes resolving data exchange problem much simpler.
</p>
</section>
<section id="slide-orgb9924ef">
<h3 id="orgb9924ef">Bonus Features</h3>
<p>
Time series for:
</p>
<ul>
<li>sizes (plain/gzipped)</li>
<li># of records</li>
<li>update periods</li>
<li># of errors</li>

</ul>
</section>
</section>
<section>
<section id="slide-orgc21d308" data-background="./images/title.jpeg">
<h2 id="orgc21d308">Questions &amp; Answers</h2>
</section>
</section>
<section>
<section id="slide-org4b01f9b">
<h2 id="org4b01f9b">Links</h2>
<p>
Slides
</p>


<div id="org380b491" class="figure">
<p><img src="./images/slides-qr.png" alt="slides-qr.png" />
</p>
</div>

<p>
<a href="https://slides-datex2-presentation-2023-virtduf-validati-23493b76d5a303.gitlab.io/">https://slides-datex2-presentation-2023-virtduf-validati-23493b76d5a303.gitlab.io/</a>
</p>
</section>
<section id="slide-orgbd05c7e">
<h3 id="orgbd05c7e">GitLab presentation group</h3>
<p>
<a href="https://gitlab.com/datex2/presentation/2023-virtduf-validation">https://gitlab.com/datex2/presentation/2023-virtduf-validation</a>:
</p>
<ul>
<li>repo: <a href="https://gitlab.com/datex2/presentation/2023-virtduf-validation/slides">slides</a> + <a href="https://gitlab.com/datex2/presentation/2023-virtduf-validation/slides/-/blob/master/public/index.org">org-mode sources</a></li>
<li>repo: <a href="https://gitlab.com/datex2/presentation/2023-virtduf-validation/pytest-validate">pytest-validate</a></li>
<li>repo: <a href="https://gitlab.com/datex2/presentation/2023-virtduf-validation/xmlstarlet-docker">xmlstarlet-docker</a></li>

</ul>
</section>
<section id="slide-orgd94d6b9">
<h3 id="orgd94d6b9">Presented applications</h3>
<p class="verse">
RAV Centre<br />
<a href="https://testcenter.datex2.eu/xmlchk/">https://testcenter.datex2.eu/xmlchk/</a><br />
</p>
<p class="verse">
NDW On-line DATEX II Validator<br />
<a href="https://d2val.staging.ndw.nu/">https://d2val.staging.ndw.nu/</a><br />
</p>

<p class="verse">
InQMS<br />
<a href="https://inqms.tamtamresearch.com/">https://inqms.tamtamresearch.com/</a><br />
</p>
</section>
<section id="slide-orgafccd3c">
<h3 id="orgafccd3c">GitLab.com/datex2</h3>
<p>
<a href="https://gitlab.com/datex2">https://gitlab.com/datex2</a>
</p>

<p>
Proof of concepts for publishing DATEX II extensions and profiles.
</p>

<p>
This is not an official DATEX II site.
</p>

<p>
Includes also materials for this presentation.
</p>
</section>
<section id="slide-orgad42dc6">
<h3 id="orgad42dc6">xmlstarlet</h3>
<p>
Command line utility to query, transform, validate, and edit XML documents and files using a simple set of shell commands in a way similar to how it is done with grep, sed, awk, diff, patch, join, etc.
</p>

<p>
<a href="https://xmlstar.sourceforge.net/">https://xmlstar.sourceforge.net/</a>
</p>

<p>
OS: Unix-like, Windows, CygWin, Mac OS
</p>

<p>
Wikipedia: <a href="https://en.wikipedia.org/wiki/XMLStarlet">https://en.wikipedia.org/wiki/XMLStarlet</a>
</p>
</section>
<section id="slide-org7b4771b" data-background="./images/title.jpeg">
<h3 id="org7b4771b">Movie: Validation (2007)</h3>
<p>
director/writer: Kurt Kuenne
</p>

<p>
<a href="https://www.imdb.com/title/tt0986272/">IMDb: Validation</a>
</p>

<p>
<a href="https://www.youtube.com/watch?v=Cbk980jV7Ao">YouTube: Validation by Kurt Kuenne</a> (16:23)
</p>

<p>
You are Awesome!!!
</p>
</section>
</section>
</div>
</div>
<script src="https://cdn.jsdelivr.net/npm/reveal.js/dist/reveal.js"></script>
<script src="https://cdn.jsdelivr.net/npm/reveal.js/plugin/markdown/markdown.js"></script>
<script src="https://cdn.jsdelivr.net/npm/reveal.js/plugin/notes/notes.js"></script>
<script src="https://cdn.jsdelivr.net/npm/reveal.js/plugin/search/search.js"></script>
<script src="https://cdn.jsdelivr.net/npm/reveal.js/plugin/zoom/zoom.js"></script>
<script>
// Full list of configuration options available here:
// https://github.com/hakimel/reveal.js#configuration
Reveal.initialize({

controls: true,
progress: true,
history: false,
center: true,
slideNumber: 'c',
rollingLinks: false,
keyboard: true,
mouseWheel: false,
fragmentInURL: false,
hashOneBasedIndex: false,
pdfSeparateFragments: true,
overview: true,

transition: 'convex',
transitionSpeed: 'default',

// Plugins with reveal.js 4.x
plugins: [ RevealMarkdown, RevealNotes, RevealSearch, RevealZoom ],

// Optional libraries used to extend reveal.js
dependencies: [
]

});
</script>
</body>
</html>
